<html>
<head>
<title>OgreBlendMode.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreBlendMode.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreBlendMode_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __BLENDMODE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __BLENDMODE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a><a class="code" href="group__Materials.html#ga1ae5925d36df27a6c3590536752264f8">00044</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#ga1ae5925d36df27a6c3590536752264f8" title="Type of texture blend mode.">LayerBlendType</a>
<a name="l00045"></a>00045     {
<a name="l00046"></a><a class="code" href="group__Materials.html#gga1ae5925d36df27a6c3590536752264f8acee3f4ef730f5c3e67fe71a54621e654">00046</a>         <a class="code" href="group__Materials.html#gga1ae5925d36df27a6c3590536752264f8acee3f4ef730f5c3e67fe71a54621e654">LBT_COLOUR</a>,
<a name="l00047"></a><a class="code" href="group__Materials.html#gga1ae5925d36df27a6c3590536752264f8a48d75d19e38ab5ff2ce7a3e9ae068e31">00047</a>         <a class="code" href="group__Materials.html#gga1ae5925d36df27a6c3590536752264f8a48d75d19e38ab5ff2ce7a3e9ae068e31">LBT_ALPHA</a>
<a name="l00048"></a>00048     };
<a name="l00049"></a>00049 
<a name="l00057"></a><a class="code" href="group__Materials.html#gabcbb38d1ac195e4be401f85b7ab0da8f">00057</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#gabcbb38d1ac195e4be401f85b7ab0da8f" title="List of valid texture blending operations, for use with TextureUnitState::setColourOperation.">LayerBlendOperation</a> {
<a name="l00059"></a><a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa870cf51ff1ccd919cf710bcb3b4e6432">00059</a>         <a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa870cf51ff1ccd919cf710bcb3b4e6432" title="Replace all colour with texture with no adjustment.">LBO_REPLACE</a>,
<a name="l00061"></a><a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa0c0abc7da3db86b393712aacc3c0ffe3">00061</a>         <a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa0c0abc7da3db86b393712aacc3c0ffe3" title="Add colour components together.">LBO_ADD</a>,
<a name="l00063"></a><a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa20815cab41c35f08f3520fb404b95efd">00063</a>         <a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa20815cab41c35f08f3520fb404b95efd" title="Multiply colour components together.">LBO_MODULATE</a>,
<a name="l00065"></a><a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa5cd300cd5790982241469d38868e5e76">00065</a>         <a class="code" href="group__Materials.html#ggabcbb38d1ac195e4be401f85b7ab0da8fa5cd300cd5790982241469d38868e5e76" title="Blend based on texture alpha.">LBO_ALPHA_BLEND</a>
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00075"></a><a class="code" href="group__Materials.html#ga264ecab38a04d01e2c3158fa05ec1ee2">00075</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#ga264ecab38a04d01e2c3158fa05ec1ee2" title="Expert list of valid texture blending operations, for use with TextureUnitState::setColourOperationEx...">LayerBlendOperationEx</a> {
<a name="l00077"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a8c7697ad29825fd74a0383826294c894">00077</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a8c7697ad29825fd74a0383826294c894" title="use source1 without modification">LBX_SOURCE1</a>,
<a name="l00079"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a7e03fbcff412dcdeefa85e7e83525599">00079</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a7e03fbcff412dcdeefa85e7e83525599" title="use source2 without modification">LBX_SOURCE2</a>,
<a name="l00081"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a985f2ec53a477d7c19b41700589cb519">00081</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a985f2ec53a477d7c19b41700589cb519" title="multiply source1 and source2 together">LBX_MODULATE</a>,
<a name="l00083"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a83964282d9ea36a25f4718ae962f8d1c">00083</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a83964282d9ea36a25f4718ae962f8d1c" title="as LBX_MODULATE but brighten afterwards (x2)">LBX_MODULATE_X2</a>,
<a name="l00085"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a2016226c35da93cc80a47e67528064a3">00085</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a2016226c35da93cc80a47e67528064a3" title="as LBX_MODULATE but brighten more afterwards (x4)">LBX_MODULATE_X4</a>,
<a name="l00087"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ac025aa3571c27a81260a08338418fa02">00087</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ac025aa3571c27a81260a08338418fa02" title="add source1 and source2 together">LBX_ADD</a>,
<a name="l00089"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ae89016c1b5b7ba57965791ae726c450e">00089</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ae89016c1b5b7ba57965791ae726c450e" title="as LBX_ADD, but subtract 0.5 from the result">LBX_ADD_SIGNED</a>,
<a name="l00091"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a94ec9bd2faf2b248f1c32f2eb187f415">00091</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a94ec9bd2faf2b248f1c32f2eb187f415" title="as LBX_ADD, but subtract product from the sum">LBX_ADD_SMOOTH</a>,
<a name="l00093"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ade0d61cb08a3a772470efeab17a1a60c">00093</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ade0d61cb08a3a772470efeab17a1a60c" title="subtract source2 from source1">LBX_SUBTRACT</a>,
<a name="l00095"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ac48b8a0a6406d7950c873658b9f11aa9">00095</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2ac48b8a0a6406d7950c873658b9f11aa9" title="use interpolated alpha value from vertices to scale source1, then add source2 scaled by (1-alpha)...">LBX_BLEND_DIFFUSE_ALPHA</a>,
<a name="l00097"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a3ba9fa36ef8c23b61e030185ca14cb78">00097</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a3ba9fa36ef8c23b61e030185ca14cb78" title="as LBX_BLEND_DIFFUSE_ALPHA, but use alpha from texture">LBX_BLEND_TEXTURE_ALPHA</a>,
<a name="l00099"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a42c0f2ce32ad504e39a11936748c9973">00099</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a42c0f2ce32ad504e39a11936748c9973" title="as LBX_BLEND_DIFFUSE_ALPHA, but use current alpha from previous stages">LBX_BLEND_CURRENT_ALPHA</a>,
<a name="l00101"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2adbe5957a946513e0f8be8c571f9b73fe">00101</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2adbe5957a946513e0f8be8c571f9b73fe" title="as LBX_BLEND_DIFFUSE_ALPHA but use a constant manual blend value (0.0-1.0)">LBX_BLEND_MANUAL</a>,
<a name="l00103"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a822d6d3e08f28dcd9834f61c7fc03905">00103</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2a822d6d3e08f28dcd9834f61c7fc03905" title="dot product of color1 and color2">LBX_DOTPRODUCT</a>,
<a name="l00105"></a><a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2aff8f459e8c642e068d2d85fb18563859">00105</a>         <a class="code" href="group__Materials.html#gga264ecab38a04d01e2c3158fa05ec1ee2aff8f459e8c642e068d2d85fb18563859" title="use interpolated color values from vertices to scale source1, then add source2 scaled by (1-color)...">LBX_BLEND_DIFFUSE_COLOUR</a>
<a name="l00106"></a>00106     };
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e">00112</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation ...">LayerBlendSource</a>
<a name="l00113"></a>00113     {
<a name="l00115"></a><a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea370f25da69381c74ca1fc51fde81e659">00115</a>         <a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea370f25da69381c74ca1fc51fde81e659" title="the colour as built up from previous stages">LBS_CURRENT</a>,
<a name="l00117"></a><a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea45f1a14042993f460992b3253ce6ae80">00117</a>         <a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea45f1a14042993f460992b3253ce6ae80" title="the colour derived from the texture assigned to this layer">LBS_TEXTURE</a>,
<a name="l00119"></a><a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea196637a598fec92609865324b94d5662">00119</a>         <a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea196637a598fec92609865324b94d5662" title="the interpolated diffuse colour from the vertices">LBS_DIFFUSE</a>,
<a name="l00121"></a><a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625eaeaaa1e434289af47d0324c5d0f19d728">00121</a>         <a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625eaeaaa1e434289af47d0324c5d0f19d728" title="the interpolated specular colour from the vertices">LBS_SPECULAR</a>,
<a name="l00123"></a><a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea9aad692ea2c7081237095c3ab4044f17">00123</a>         <a class="code" href="group__Materials.html#ggae2ad78de344f35307ce35157c175625ea9aad692ea2c7081237095c3ab4044f17" title="a colour supplied manually as a separate argument">LBS_MANUAL</a>
<a name="l00124"></a>00124     };
<a name="l00139"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html">00139</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141     <span class="keyword">public</span>:
<a name="l00143"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#ac2cb8de7b805400726882f7003a4bcda">00143</a>         <a class="code" href="group__Materials.html#ga1ae5925d36df27a6c3590536752264f8" title="Type of texture blend mode.">LayerBlendType</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#ac2cb8de7b805400726882f7003a4bcda" title="The type of blending (colour or alpha)">blendType</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#afc151f1c17683cd99df776459df2c778">00145</a>         <a class="code" href="group__Materials.html#ga264ecab38a04d01e2c3158fa05ec1ee2" title="Expert list of valid texture blending operations, for use with TextureUnitState::setColourOperationEx...">LayerBlendOperationEx</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#afc151f1c17683cd99df776459df2c778" title="The operation to be applied.">operation</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a334818129ca44c1fbdba2b3b2813368a">00147</a>         <a class="code" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation ...">LayerBlendSource</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a334818129ca44c1fbdba2b3b2813368a" title="The first source of colour/alpha.">source1</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a94eeae80ba84e9aa5271d317d48f2688">00149</a>         <a class="code" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation ...">LayerBlendSource</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a94eeae80ba84e9aa5271d317d48f2688" title="The second source of colour/alpha.">source2</a>;
<a name="l00150"></a>00150 
<a name="l00152"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a99adb8004759bf3825d934684ab8f171">00152</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a99adb8004759bf3825d934684ab8f171" title="Manual colour value for manual source1.">colourArg1</a>;
<a name="l00154"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a6bd40927e40bcb2d6c4e077ebd56c24d">00154</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a6bd40927e40bcb2d6c4e077ebd56c24d" title="Manual colour value for manual source2.">colourArg2</a>;
<a name="l00156"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a8af3aad5d2de939d0d9bff3049c82928">00156</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a8af3aad5d2de939d0d9bff3049c82928" title="Manual alpha value for manual source1.">alphaArg1</a>;
<a name="l00158"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a9dde2b63904e61319b175094f8fc67f0">00158</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a9dde2b63904e61319b175094f8fc67f0" title="Manual alpha value for manual source2.">alphaArg2</a>;
<a name="l00160"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a71cee0ade264a82051913d5eb0fc4c40">00160</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LayerBlendModeEx.html#a71cee0ade264a82051913d5eb0fc4c40" title="Manual blending factor.">factor</a>;
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a4c678a65c3a32728622812d2784c2e6d">00162</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00163"></a>00163 <span class="keyword">        </span>{
<a name="l00164"></a>00164             <span class="keywordflow">if</span> (blendType != rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#ac2cb8de7b805400726882f7003a4bcda" title="The type of blending (colour or alpha)">blendType</a>) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166             <span class="keywordflow">if</span> (blendType == <a class="code" href="group__Materials.html#gga1ae5925d36df27a6c3590536752264f8acee3f4ef730f5c3e67fe71a54621e654">LBT_COLOUR</a>)
<a name="l00167"></a>00167             {
<a name="l00168"></a>00168 
<a name="l00169"></a>00169                 <span class="keywordflow">if</span> (operation == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#afc151f1c17683cd99df776459df2c778" title="The operation to be applied.">operation</a> &amp;&amp;
<a name="l00170"></a>00170                     source1 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a334818129ca44c1fbdba2b3b2813368a" title="The first source of colour/alpha.">source1</a> &amp;&amp;
<a name="l00171"></a>00171                     source2 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a94eeae80ba84e9aa5271d317d48f2688" title="The second source of colour/alpha.">source2</a> &amp;&amp;
<a name="l00172"></a>00172                     colourArg1 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a99adb8004759bf3825d934684ab8f171" title="Manual colour value for manual source1.">colourArg1</a> &amp;&amp;
<a name="l00173"></a>00173                     colourArg2 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a6bd40927e40bcb2d6c4e077ebd56c24d" title="Manual colour value for manual source2.">colourArg2</a> &amp;&amp;
<a name="l00174"></a>00174                     factor == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a71cee0ade264a82051913d5eb0fc4c40" title="Manual blending factor.">factor</a>)
<a name="l00175"></a>00175                 {
<a name="l00176"></a>00176                     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00177"></a>00177                 }
<a name="l00178"></a>00178             }
<a name="l00179"></a>00179             <span class="keywordflow">else</span> <span class="comment">// if (blendType == LBT_ALPHA)</span>
<a name="l00180"></a>00180             {
<a name="l00181"></a>00181                 <span class="keywordflow">if</span> (operation == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#afc151f1c17683cd99df776459df2c778" title="The operation to be applied.">operation</a> &amp;&amp;
<a name="l00182"></a>00182                     source1 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a334818129ca44c1fbdba2b3b2813368a" title="The first source of colour/alpha.">source1</a> &amp;&amp;
<a name="l00183"></a>00183                     source2 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a94eeae80ba84e9aa5271d317d48f2688" title="The second source of colour/alpha.">source2</a> &amp;&amp;
<a name="l00184"></a>00184                     alphaArg1 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a8af3aad5d2de939d0d9bff3049c82928" title="Manual alpha value for manual source1.">alphaArg1</a> &amp;&amp;
<a name="l00185"></a>00185                     alphaArg2 == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a9dde2b63904e61319b175094f8fc67f0" title="Manual alpha value for manual source2.">alphaArg2</a> &amp;&amp;
<a name="l00186"></a>00186                     factor == rhs.<a class="code" href="classOgre_1_1LayerBlendModeEx.html#a71cee0ade264a82051913d5eb0fc4c40" title="Manual blending factor.">factor</a>)
<a name="l00187"></a>00187                 {
<a name="l00188"></a>00188                     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00189"></a>00189                 }
<a name="l00190"></a>00190             }
<a name="l00191"></a>00191             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00192"></a>00192         }
<a name="l00193"></a>00193 
<a name="l00194"></a><a class="code" href="classOgre_1_1LayerBlendModeEx.html#a1ea4fff299261c723f025337c513dc88">00194</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00195"></a>00195 <span class="keyword">        </span>{
<a name="l00196"></a>00196             <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == rhs);
<a name="l00197"></a>00197         }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     };
<a name="l00202"></a>00202 
<a name="l00215"></a><a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a">00215</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a>
<a name="l00216"></a>00216     {
<a name="l00218"></a><a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aa8df6dd8b7710971196000da11b5ab114">00218</a>         <a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aa8df6dd8b7710971196000da11b5ab114" title="Make the object transparent based on the final alpha values in the texture.">SBT_TRANSPARENT_ALPHA</a>,
<a name="l00220"></a><a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aab57b2cf11c74056c5109fce1efa37a05">00220</a>         <a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aab57b2cf11c74056c5109fce1efa37a05" title="Make the object transparent based on the colour values in the texture (brighter = more opaque)...">SBT_TRANSPARENT_COLOUR</a>,
<a name="l00222"></a><a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aafa3ba1b1c044f8c0cb09bc41582024d4">00222</a>         <a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aafa3ba1b1c044f8c0cb09bc41582024d4" title="Add the texture values to the existing scene content.">SBT_ADD</a>,
<a name="l00224"></a><a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aa7aed8ef0038f0a0a5f6634ba4080b513">00224</a>         <a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aa7aed8ef0038f0a0a5f6634ba4080b513" title="Multiply the 2 colours together.">SBT_MODULATE</a>,
<a name="l00226"></a><a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aab6672abe57fa6051e9ab57d51975d244">00226</a>         <a class="code" href="group__Materials.html#ggac46c60cf6e5c199220e3b8f26570cb9aab6672abe57fa6051e9ab57d51975d244" title="The default blend mode where source replaces destination.">SBT_REPLACE</a>
<a name="l00227"></a>00227         <span class="comment">// TODO : more</span>
<a name="l00228"></a>00228     };
<a name="l00229"></a>00229 
<a name="l00234"></a><a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213">00234</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a>
<a name="l00235"></a>00235     {
<a name="l00236"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213ad2741858a9d9f668a47ea75b82ae0318">00236</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213ad2741858a9d9f668a47ea75b82ae0318">SBF_ONE</a>,
<a name="l00237"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a04732209b3c7a16b5f0a2c829e6f6c34">00237</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a04732209b3c7a16b5f0a2c829e6f6c34">SBF_ZERO</a>,
<a name="l00238"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213affe55d98f2cd26e9451af52dbc74f7b2">00238</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213affe55d98f2cd26e9451af52dbc74f7b2">SBF_DEST_COLOUR</a>,
<a name="l00239"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213aec796e9f58f4cce849379f0239e059a6">00239</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213aec796e9f58f4cce849379f0239e059a6">SBF_SOURCE_COLOUR</a>,
<a name="l00240"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a7ea50d3d5960138db1c46ecb42f94969">00240</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a7ea50d3d5960138db1c46ecb42f94969">SBF_ONE_MINUS_DEST_COLOUR</a>,
<a name="l00241"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a93b05f61a5076cf0f649ac5d656970fe">00241</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a93b05f61a5076cf0f649ac5d656970fe">SBF_ONE_MINUS_SOURCE_COLOUR</a>,
<a name="l00242"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a374792bd937134c4ca2aad748661c22c">00242</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a374792bd937134c4ca2aad748661c22c">SBF_DEST_ALPHA</a>,
<a name="l00243"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a5b1a11e0ec0d1cf0bdab0176cca26eea">00243</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a5b1a11e0ec0d1cf0bdab0176cca26eea">SBF_SOURCE_ALPHA</a>,
<a name="l00244"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a1d772950d5ec934776bbc1d39782a42d">00244</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a1d772950d5ec934776bbc1d39782a42d">SBF_ONE_MINUS_DEST_ALPHA</a>,
<a name="l00245"></a><a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a09184af2d875978d03c6edd00d4d52f9">00245</a>         <a class="code" href="group__Materials.html#gga41c76d419d6c9c205a6c1d3b42872213a09184af2d875978d03c6edd00d4d52f9">SBF_ONE_MINUS_SOURCE_ALPHA</a>
<a name="l00246"></a>00246 
<a name="l00247"></a>00247     };
<a name="l00248"></a>00248 
<a name="l00253"></a><a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a">00253</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a>
<a name="l00254"></a>00254     {
<a name="l00255"></a><a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa188aee58620b3275f1a45c7c80df4bc7">00255</a>         <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa188aee58620b3275f1a45c7c80df4bc7">SBO_ADD</a>,
<a name="l00256"></a><a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa1b91fc44108cc88f2cb4bb38d4d76a4b">00256</a>         <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa1b91fc44108cc88f2cb4bb38d4d76a4b">SBO_SUBTRACT</a>,
<a name="l00257"></a><a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aabf264a7da02c6b481ca9a8b222914438">00257</a>         <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aabf264a7da02c6b481ca9a8b222914438">SBO_REVERSE_SUBTRACT</a>,
<a name="l00258"></a><a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aaac9096763a660cde89c5771a7842d14c">00258</a>         <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aaac9096763a660cde89c5771a7842d14c">SBO_MIN</a>,
<a name="l00259"></a><a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aad27eb8ec55b3c43ff95506da8e2b3d7f">00259</a>         <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aad27eb8ec55b3c43ff95506da8e2b3d7f">SBO_MAX</a>
<a name="l00260"></a>00260     };
<a name="l00264"></a>00264 }
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
